;HDPASS.ASM
cseg             segment
                 assume cs:cseg,ds:cseg
                 org 100h
start:           jmp install

buf_len          equ 16
sector           equ 3

int13:           jmp short int13_1

flag             dw ?
x1               db ?
oldint13         dw ?,?
buffer1          db buf_len dup (?),?

int13_1:         push es
                 push bx
                 push dx
                 push si
                 push cs
                 pop es
                 mov bx,offset ii3
                 mov dx,offset jm-ii3
                 mov si,offset buffer1
                 call jm
                 pop si
                 mov dx,offset ii3-int13-2
                 mov byte ptr cs:int13+1,dl
                 pop dx
                 pop bx
                 pop es
ii3:             cmp ah,02h
                 jne f1
                 cmp dx,0080h
                 jne f1
                 cmp cx,0001h
                 je i1
f1:              jmp dword ptr cs:oldint13
i1:              push bp
                 mov bp,sp
                 push [bp+6]
                 pop cs:flag
                 pop bp
                 mov cl,sector
                 mov cs:x1,al
                 mov al,1
                 push cs:flag
                 call dword ptr cs:oldint13
                 jc i3
                 mov al,cs:x1
                 dec al
                 jz i2
                 push bx
                 add bx,512
                 mov cl,2
                 mov ah,2
                 pushf
                 call dword ptr cs:oldint13
                 pop bx
                 jc i3
i2:              pushf
                 push si
                 push dx
                 mov dx,512
                 mov si,offset buffer1
                 call jm
                 pop dx
                 pop si
                 popf
i3:              sti
                 mov cl,1
                 retf 2

jm               proc near
                 push ds
                 push ax
                 push bx
                 push cx
                 push cs
                 pop ds
                 cld
j0:              mov cl,1
                 push si
j1:              lodsb
                 cmp al,0
                 jne j2
                 pop si
                 jmp j0
j2:              ror al,cl
                 xor al,dl
                 xor es:[bx],al
                 inc bx
                 inc cx
                 dec dx
                 jnz j1
                 pop si
                 pop cx
                 pop bx
                 pop ax
                 pop ds
                 ret
jm               endp

tsr_len          equ $-offset int13

                 org 0600h

boot:            cli
                 xor ax,ax
                 mov ss,ax
                 mov sp,7c00h
                 mov si,sp
                 push ax
                 pop es
                 push ax
                 pop ds
                 sti
                 cld
                 mov di,offset boot
                 mov cx,100h
                 repnz movsw
                 db 0eah
                 dw offset b1,0
b1:              mov si,offset msg1
                 call disp_msg
                 mov di,offset buffer
                 call read_key
                 lea si,[di+1]
                 mov dl,0
                 mov cl,1
b2:              lodsb
                 cmp al,0
                 je b3
                 ror al,cl
                 sub dl,al
                 inc cl
                 jmp b2
b3:              cmp dl,byte ptr key
                 je b4
                 mov si,offset msg2
                 call disp_msg
                 jmp b1
b4:              mov si,offset cr
                 call disp_msg
                 mov ax,ds:[413h]
                 dec ax
                 mov ds:[413h],ax
                 mov cl,6
                 shl ax,cl
                 mov es,ax
                 mov cx,tsr_len
                 mov di,offset int13
                 mov si,offset key+1
                 rep movsb
                 mov si,offset buffer+1
                 mov di,offset buffer1
                 mov cx,buf_len+1
                 rep movsb
                 mov ax,ds:[4*13h]
                 mov es:oldint13,ax
                 mov ax,ds:[4*13h+2]
                 mov es:oldint13+2,ax
                 mov ds:[4*13h],offset int13
                 mov ds:[4*13h+2],es
                 mov ax,0201h
                 mov cx,1
                 mov dx,0080h
                 mov bx,7c00h
                 push cs
                 pop es
                 int 13h
                 jmp bx

disp_msg         proc near
                 cld
d1:              lodsb
                 cmp al,0
                 je d2
                 mov ah,0eh
                 mov bl,7
                 int 10h
                 jmp d1
d2:              ret
disp_msg         endp

read_key         proc near
                 push di
                 mov cl,[di]
                 mov bp,di
r0:              inc di
r1:              mov ah,0
                 int 16h
                 cmp al,0
                 je r1
                 cmp al,0dh
                 je r4
                 cmp al,8
                 jne r3
                 dec di
                 cmp di,bp
                 je r0
                 mov si,offset msg3
                 call disp_msg
                 inc cl
                 jmp r1
r3:              or cl,cl
                 jz r1
                 mov [di],al
                 inc di
                 dec cl
                 mov si,offset msg4
                 call disp_msg
                 jmp r1
r4:              mov byte ptr [di],0
                 pop di
                 ret
read_key         endp

msg1             db 'Password: ',0
msg2             db 7,13,10,'ERROR!'
cr               db 13,10,0
msg3             db 8,20h,8,0
msg4             db '*',0
buffer           db buf_len,buf_len dup (?),?
key              db ?

install:         jmp xx1

                 db 512 dup (?)

m1               db 13,10,'Enter  Password: ',24h
m2               db 13,10,'Verify Password: ',24h
m3               db 13,10,'Invalid Password',13,10,24h
m4               db 13,10,'Install Fault',13,10,24h
m5               db 13,10,'Install OK',13,10,24h
m6               db 13,10,'QUIT',13,10,24h
buf1             db buf_len,buf_len dup (?),?
buf2             db buf_len,buf_len dup (?),?

xx1:
                 mov ax,0201h
                 mov cx,1
                 mov dx,80h
                 mov bx,offset buf3
                 int 13h
                 jc q11
                 mov dx,offset m1
                 mov ah,9
                 int 21h
                 mov di,offset buf1
                 call read_key
                 mov dx,offset m2
                 mov ah,9
                 int 21h
                 mov di,offset buf2
                 call read_key
                 cmp byte ptr buf1+1,0
                 jne x2
                 mov dx,offset m6
                 jmp quit
x2:              mov si,offset buf1
                 mov di,offset buf2
                 mov cx,buf_len+1
                 cld
x21:             cmpsb
                 jne x22
                 cmp byte ptr [si-1],0
                 je x3
                 jmp x21
x22:             mov dx,offset m3
                 jmp quit
x3:              mov si,offset buf1+1
                 mov dl,0
                 mov cl,1
x4:              lodsb
                 cmp al,0
                 je x5
                 ror al,cl
                 sub dl,al
                 inc cl
                 jmp x4
x5:              mov byte ptr key,dl
                 mov dx,512
                 mov bx,offset buf3
                 mov si,offset buf1+1
                 call jm
                 mov ax,0301h
                 mov cx,sector
                 mov dx,80h
                 mov bx,offset buf3
                 int 13h
q11:             jc q12
                 mov dx,offset jm-ii3
                 mov bx,offset ii3
                 mov si,offset buf1+1
                 call jm
                 mov si,offset int13
                 mov di,offset install
                 mov cx,tsr_len
                 rep movsb
                 mov si,offset boot+510
                 mov word ptr [si],0aa55h
                 mov ax,0301h
                 mov cx,1
                 mov dx,80h
                 mov bx,offset boot
                 int 13h
q12:             jc q1
                 mov dx,offset m5
quit:            mov ah,9
                 int 21h
                 mov ax,4c00h
                 int 21h

q1:              mov dx,offset m4
                 mov ah,9
                 int 21h
                 mov ax,4c01h
                 int 21h

buf3             label byte


cseg             ends
                 end start
